/**

Ce programme est optimisé pour Processing dans sa version 1.5.1

Lycée Jean-Perrin

*/

//importation des librairies
import java.io.*;
import processing.opengl.*;
import jp.nyatla.nyar4psg.*;
import codeanticode.gsvideo.*;

//initialisation des variables
GSCapture cam;
MultiMarker nya_1; // variable 1
MultiMarker nya_2; // variable 2
MultiMarker nya_3; // variable 3
MultiMarker nya_4; // variable 4 
MultiMarker nya_5; // variable 5
int fps = 30;  // définit le nombre de fps (frame per second)
GSMovieMaker  mm;  //variable pour l'enregistrement du flux vidéo

void setup() {
    // enregistrement
    mm = new GSMovieMaker (this, width, height, "drawing1.ogg", GSMovieMaker.THEORA, GSMovieMaker.MEDIUM, fps);
    mm.start(); // créé le fichier "drawing1.ogg" et commence l'enregistrement   
 size(640,480,P3D); // définition de la taille de la fenêtre d'affichage
 colorMode(RGB, 100); // définit le mode de couleur interprêté par processing, en RGB ici
 println(MultiMarker.VERSION); // affiche dans la zone de texte l'évolution d'un type de variable
 cam=new GSCapture(this,640,480); // définit la taille de capture du flux
 cam.start(); // lance l'aquisition du flux vidéo
 
//déclaration des markers, on associe un marker à un pattern
 //marker1
 nya_1=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_LEFT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_1.addARMarker("marker1.patt",80);

 //marker2
 nya_2=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_2.addARMarker("marker2.patt",80);

 //marker3
 nya_3=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_LEFT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_3.addARMarker("marker3.patt",80);

//marker4

 nya_4=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_4.addARMarker("marker4.patt",80);

//marker5   
 nya_5=new MultiMarker(this,width,height,"camera_para.dat",new NyAR4PsgConfig(NyAR4PsgConfig.CS_RIGHT_HAND,NyAR4PsgConfig.TM_NYARTK));
 nya_5.addARMarker("marker5.patt",80);
}

int c=0;
void drawgrid() //implemente un quadrillage
{
 pushMatrix(); //sauvegarde les changements de coordonnées
 stroke(0); //définit la couleur utilisée pour dessiner des lignes et des bordures autour des formes (en RGB de 0 à 255)
 strokeWeight(2); //définit la taille des lignes et des bordures autour des formes
 popMatrix(); //réinitialise les changements de coordonées
}

void draw() //implemente le dessin des objets liés aux markers
{
  c++;
  if (cam.available() !=true) { // permet de vérifier la présence d'une webcam
   return;
 }

 //initialisation des markers à détecter
 cam.read(); // lance la lecture du flux
 image(cam, 0, 0, 640, 480);  
 nya_1.detect(cam);  // détection du marker1
 nya_2.detect(cam);  // détection du marker2
 nya_3.detect(cam);  // détection du marker3
 nya_4.detect(cam);  // détection du marker4
 nya_5.detect(cam);  // détection du marker5

 background(0); //définit la couleur de la fenêtre processing en RGB (valeur de 0 à 255)

 //initialisation d'une police de texte

 PFont w; //définition de la variable 
 w = createFont("Comic sans MS",35,true); //affectation des valeurs de la variable lié au modification de texte
 
 nya_1.drawBackground(cam);
 nya_5.drawBackground(cam);

 //marker 1
  if((nya_1.isExistMarker(0))){ //fonction "si", si le marqueur 1 est présent executé la suite.
   nya_1.beginTransform(0); //début des modifications virtuelles
    fill(0,0,255); //permet le changement de couleur de fonction (r,g,b)
    drawgrid();
    rotate(0); //permet la rotation avec une valeur angulaire
    textFont(w);  //utilisation de la police de texte défini plus haut
    text("Bienvenue", -50, 0);   //afficher le texte "Bienvenue", de type text(".....",x,y)
    nya_1.endTransform(); //fin des modifications virtuelles
 }

 //marker 2

 if((nya_2.isExistMarker(0))){
    nya_2.beginTransform(0);
    fill(0,255,0);
    drawgrid();
    rotate(0);
    textFont(w);
    text("au lycée Jean-Perrin", -150, 0);
    nya_2.endTransform();
 }

//marker 3
    if((nya_3.isExistMarker(0))){
    nya_3.beginTransform(0);
    PImage sti2d; //déclaration d'une image
    sti2d = loadImage("sti2d.jpg");  //charger l'image "sti2d.jpg" et l'associe à la variable "sti2d"
    image(sti2d,-50,-25,100,50); //appel l'image (image, coord-X, ccord-Y, hauteur, largeur)
    fill(0,0,255);
    drawgrid();
    rotate(0);
    nya_3.endTransform();

 }

//marker 4

if((nya_4.isExistMarker(0))){
    nya_4.beginTransform(0);
    fill(0,255,0,100);
    drawgrid();
    translate(0,0,20); //définit la place de l'objet dans le repère (x,y,z) en fonction de la fenêtre
    rotate((float)c/100); // angle défini en radian par le biais de la fonction de float
    box(40); //affichage d'un cube de taille (x)
    nya_4.endTransform();
 }

//marker5

 if((nya_5.isExistMarker(0))){
    nya_5.beginTransform(0);
    fill(0,255,255);
    drawgrid();
    translate(0,0,20);
    rotate((float)c/100);
    sphere(40); //affichage d'une sphère de taille (x)
    nya_5.endTransform();
 }
 
 loadPixels(); // charge les pixels pour enregistrer le flux vidéo
  mm.addFrame(pixels); // ajoute les images au fichier vidéo depuis les pixels chargés
} 
void keyPressed() // fonction qui permet d'utiliser le clavier
{
  if (key == ' ') // associe la fonction suivante à la barre d'espace
  {
    mm.finish(); //stoppe l'enregistrement si la barre d'espace est appuyée
   exit(); // quitte le programme une fois le fichier écrit
  }
 
} //fin du programme

